/* -*- Mode: C; c-file-style: "bsd"; -*- */

/* Realeger Real relation */

#include <math.h>
#include <string.h>

#include "int.h"
#include "real.h"
#include "nxp_string.h"
#include "op_bindings.h"
#include "types_misc.h"

#define BIND_SYM(func,op)    nxp_bind_operator_function(op, NXP_ELEMENT_TYPE_STRING, \
							NXP_ELEMENT_TYPE_REAL, \
							func, func, NXP_OP_BIND_SYMMETRIC, NULL);


static NxpElement* or(NxpOp op, NxpElement *a, NxpElement *b, 
		       NxpEvalContext *context, GError **error) {
	return nxp_element_int_new((strlen(NXP_ELEMENT_STRING(a)->string))?1:mpfr_sgn(NXP_ELEMENT_REAL(b)->value));
}

static NxpElement* and(NxpOp op, NxpElement *a, NxpElement *b, 
		       NxpEvalContext *context, GError **error) {
	return nxp_element_int_new((strlen(NXP_ELEMENT_STRING(a)->string))?mpfr_sgn(NXP_ELEMENT_REAL(b)->value):0);
}



void nxp_element_string_real_init(GError **error)
{
    
    // BIND_SYM(add_them, NXP_OP_PLUS);
    // NXP_OP_MINUS_LEFT 
    // BIND_SYM(mult_them,NXP_OP_STAR);

    //  BIND_REAL_REAL(sub_real_real, NXP_OP_MINUS);
    //  BIND_REAL_REAL(sub_real_real, NXP_OP_MINUS);

    // BIND_REAL_REAL(div_real_real, NXP_OP_SLASH);
    // BIND_REAL_REAL(div_real_real, NXP_OP_SLASH);

    // BIND_REAL_REAL(hat_real_real, NXP_OP_HAT);
    // BIND_REAL_REAL(hat_real_real, NXP_OP_HAT);

    // NXP_OP_DOT3... TODO
  
    // PLUS2_left/right MINUS2/left/right in real.c or real.c

    // BIND_REAL_REAL(gt_real_real, NXP_OP_GT);
    // BIND_REAL_REAL(gt_real_real, NXP_OP_GT);

    // BIND_REAL_REAL(lt_real_real, NXP_OP_LT);
    // BIND_REAL_REAL(lt_real_real, NXP_OP_LT);

    // BIND_REAL_REAL(gte_real_real, NXP_OP_GT_EQ);
    // BIND_REAL_REAL(gte_real_real, NXP_OP_GT_EQ);

    //BIND_REAL_REAL(lte_real_real, NXP_OP_LT_EQ);
    // BIND_REAL_REAL(lte_real_real, NXP_OP_LT_EQ);

    // BIND_SYM(equals,NXP_OP_EQ2);
    // BIND_SYM(nequals,NXP_OP_EXCL_EQ);

    BIND_SYM(and, NXP_OP_SLASH_BSLASH);
    BIND_SYM(or,  NXP_OP_BSLASH_SLASH);

    // TILDE LEFT is handled under real.c or real.c
    // EXCL_RIGHT is handled under real.c or real.c

    // BIND_SYM(atrib_error, NXP_OP_EQ);
    // BIND_SYM(atrib_error, NXP_OP_COLON_EQ);
}

