/* -*- Mode: C; c-file-style: "bsd"; -*- */
#include "void.h"
#include "op_bindings.h"
#include "types_misc.h"


static NxpElementTypeInfo *typeinfo = NULL;

static NxpElement *void_element = NULL;


NxpElement* nxp_element_void_new(void) 
{
    return NXP_ELEMENT_REF(void_element);
}


static GString* str_func(NxpElement *el, int *precedence)
{
    if (precedence) *precedence = 0;
    return g_string_new("void");
}

int nxp_element_void_get_type(void)
{
    static int nxp_element_type_void = -1;

    if (nxp_element_type_void == -1) {
	nxp_element_type_void = 0;
	typeinfo = nxp_element_type_register_info(
					    nxp_element_type_void,
					    sizeof(NxpElementTypeInfo),
					    0,
					    sizeof(NxpElementTypeInfo));
    }
    return nxp_element_type_void;
}

void nxp_element_void_type_init()
{
    g_return_if_fail(!typeinfo);
    typeinfo = nxp_element_type_get_info(nxp_element_void_get_type());
    typeinfo->name = g_strdup("void");
    typeinfo->eval_func = nxp_eval_return_self;
    typeinfo->simplify_func = nxp_eval_return_self;
    typeinfo->str_func = str_func;
    typeinfo->repr_func = str_func;
    void_element = nxp_element_alloc(typeinfo, sizeof(NxpElementVoid));
}

