/* -*- c -*-  */
#include <gsl/gsl_sf_elljac.h>
#include "nxp_kernel.h"
#include "gsl.h"

/*
 * STATUS: Done 
 */

static NxpElement *
nxp_gsl_sf_elljac_e(NxpElementReal * U, NxpElementReal * M, ETC)
{
    double          SN,
                    CN,
                    DN;
    NxpElement     *result;

    gsl_sf_elljac_e(nxp_element_r_get_value_as_double(U), nxp_element_r_get_value_as_double(M), &SN, &CN, &DN);
    result = nxp_element_vector_new(3, NULL);
    NXP_ELEMENT_VECTOR_ELEM(NXP_ELEMENT_VECTOR(result), 0) =
	nxp_element_real_new(SN);
    NXP_ELEMENT_VECTOR_ELEM(NXP_ELEMENT_VECTOR(result), 1) =
	nxp_element_real_new(CN);
    NXP_ELEMENT_VECTOR_ELEM(NXP_ELEMENT_VECTOR(result), 2) =
	nxp_element_real_new(DN);
    GSL_RETURN(result)
}

void
nxp_gsl_sf_elljac_init(NxpEvalContext * context)
{
    NxpIdentifier  *id;
nxp_name_space_new(context->cwd,"gsl");
nxp_name_space_new(nxp_name_space_find_child(context->cwd,"gsl"),"elljac");
id = nxp_identifier_new_with_full_path(3,"gsl","elljac", "elljac");
 nxp_bifunc_define(id, &nxp_prototype__REAL_REAL, nxp_gsl_sf_elljac_e, NULL, nxp_gsl_sf_elljac_e, context, NULL); nxp_identifier_unref(id);
}
