/* -*- c -*-  */
#include <gsl/gsl_sf_erf.h>
#include "nxp_kernel.h"
#include "gsl.h"

/*
 * STATUS: Done 
 */

static NxpElement *nxp_gsl_sf_erf(NxpElementReal *arg1, ETC)
{
	nxp_real_t ret;
	ret = gsl_sf_erf(nxp_element_r_get_value_as_double(NXP_ELEMENT_R(arg1)));
	GSL_RETURN(nxp_element_real_new(ret));
}

static NxpElement *nxp_gsl_sf_erfc(NxpElementReal *arg1, ETC)
{
	nxp_real_t ret;
	ret = gsl_sf_erfc(nxp_element_r_get_value_as_double(NXP_ELEMENT_R(arg1)));
	GSL_RETURN(nxp_element_real_new(ret));
}

static NxpElement *nxp_gsl_sf_log_erfc(NxpElementReal *arg1, ETC)
{
	nxp_real_t ret;
	ret = gsl_sf_log_erfc(nxp_element_r_get_value_as_double(NXP_ELEMENT_R(arg1)));
	GSL_RETURN(nxp_element_real_new(ret));
}

static NxpElement *nxp_gsl_sf_erf_Z(NxpElementReal *arg1, ETC)
{
	nxp_real_t ret;
	ret = gsl_sf_erf_Z(nxp_element_r_get_value_as_double(NXP_ELEMENT_R(arg1)));
	GSL_RETURN(nxp_element_real_new(ret));
}

static NxpElement *nxp_gsl_sf_erf_Q(NxpElementReal *arg1, ETC)
{
	nxp_real_t ret;
	ret = gsl_sf_erf_Q(nxp_element_r_get_value_as_double(NXP_ELEMENT_R(arg1)));
	GSL_RETURN(nxp_element_real_new(ret));
}


void
nxp_gsl_sf_erf_init(NxpEvalContext * context)
{
    NxpIdentifier  *id;
nxp_name_space_new(context->cwd,"gsl");
nxp_name_space_new(nxp_name_space_find_child(context->cwd,"gsl"),"erf");
id = nxp_identifier_new_with_full_path(3,"gsl","erf", "erf");
 nxp_bifunc_define(id, &nxp_prototype__REAL, nxp_gsl_sf_erf, NULL, nxp_gsl_sf_erf, context, NULL); nxp_identifier_unref(id);
id = nxp_identifier_new_with_full_path(3,"gsl","erf", "erfc");
 nxp_bifunc_define(id, &nxp_prototype__REAL, nxp_gsl_sf_erfc, NULL, nxp_gsl_sf_erfc, context, NULL); nxp_identifier_unref(id);
id = nxp_identifier_new_with_full_path(3,"gsl","erf", "logErfc");
 nxp_bifunc_define(id, &nxp_prototype__REAL, nxp_gsl_sf_log_erfc, NULL, nxp_gsl_sf_log_erfc, context, NULL); nxp_identifier_unref(id);
id = nxp_identifier_new_with_full_path(3,"gsl","erf", "erfZ");
 nxp_bifunc_define(id, &nxp_prototype__REAL, nxp_gsl_sf_erf_Z, NULL, nxp_gsl_sf_erf_Z, context, NULL); nxp_identifier_unref(id);
id = nxp_identifier_new_with_full_path(3,"gsl","erf", "erfQ");
 nxp_bifunc_define(id, &nxp_prototype__REAL, nxp_gsl_sf_erf_Q, NULL, nxp_gsl_sf_erf_Q, context, NULL); nxp_identifier_unref(id);
}
