/* -*- c -*- */
#include <gsl/gsl_sf_gegenbauer.h>
#include "nxp_kernel.h"
#include "gsl.h"

static NxpElement *nxp_gsl_sf_gegenpoly_1(NxpElementReal *arg1 ,NxpElementReal *arg2, ETC)
{
	nxp_real_t ret;
	ret = gsl_sf_gegenpoly_1(nxp_element_r_get_value_as_double(NXP_ELEMENT_R(arg1)) ,nxp_element_r_get_value_as_double(NXP_ELEMENT_R(arg2)));
	GSL_RETURN(nxp_element_real_new(ret));
}

static NxpElement *nxp_gsl_sf_gegenpoly_2(NxpElementReal *arg1 ,NxpElementReal *arg2, ETC)
{
	nxp_real_t ret;
	ret = gsl_sf_gegenpoly_2(nxp_element_r_get_value_as_double(NXP_ELEMENT_R(arg1)) ,nxp_element_r_get_value_as_double(NXP_ELEMENT_R(arg2)));
	GSL_RETURN(nxp_element_real_new(ret));
}

static NxpElement *nxp_gsl_sf_gegenpoly_3(NxpElementReal *arg1 ,NxpElementReal *arg2, ETC)
{
	nxp_real_t ret;
	ret = gsl_sf_gegenpoly_3(nxp_element_r_get_value_as_double(NXP_ELEMENT_R(arg1)) ,nxp_element_r_get_value_as_double(NXP_ELEMENT_R(arg2)));
	GSL_RETURN(nxp_element_real_new(ret));
}

static NxpElement *nxp_gsl_sf_gegenpoly_n(NxpElementInt *arg1 ,NxpElementReal *arg2 ,NxpElementReal *arg3, ETC)
{
	nxp_real_t ret;
	ret = gsl_sf_gegenpoly_n(nxp_element_int_get_si(NXP_ELEMENT_INT(arg1), error) ,nxp_element_r_get_value_as_double(NXP_ELEMENT_R(arg2)) ,nxp_element_r_get_value_as_double(NXP_ELEMENT_R(arg3)));
	GSL_RETURN(nxp_element_real_new(ret));
}


NxpElement     *
nxp_gsl_sf_gegenpoly_array(NxpElementInt * NMAX,
			   NxpElementReal * LAMBDA,
			   NxpElementReal * X, ETC)
{
    NxpElement     *array;
    int             i,
                    size = nxp_element_r_get_value_as_int(NMAX);
    double         *RESULT_ARRAY;
    RESULT_ARRAY = g_new(double, size + 1);

    array = nxp_element_vector_new(size + 1, NULL);
    gsl_sf_gegenpoly_array(size, nxp_element_r_get_value_as_double(LAMBDA), nxp_element_r_get_value_as_double(X), RESULT_ARRAY);

    for (i = 0; i < size + 1; i++) {
	_element_vector_index(NXP_ELEMENT_VECTOR(array), i) =
	    nxp_element_real_new(RESULT_ARRAY[i]);
    }

    g_free(RESULT_ARRAY);

    GSL_RETURN(array);
}

void
nxp_gsl_sf_gegenbauer_init(NxpEvalContext * context)
{
    NxpIdentifier  *id;
nxp_name_space_new(context->cwd,"gsl");
nxp_name_space_new(nxp_name_space_find_child(context->cwd,"gsl"),"gegenbauer");
id = nxp_identifier_new_with_full_path(3,"gsl","gegenbauer", "poly1");
 nxp_bifunc_define(id, &nxp_prototype__REAL_REAL, nxp_gsl_sf_gegenpoly_1, NULL, nxp_gsl_sf_gegenpoly_1, context, NULL); nxp_identifier_unref(id);
id = nxp_identifier_new_with_full_path(3,"gsl","gegenbauer", "poly2");
 nxp_bifunc_define(id, &nxp_prototype__REAL_REAL, nxp_gsl_sf_gegenpoly_2, NULL, nxp_gsl_sf_gegenpoly_2, context, NULL); nxp_identifier_unref(id);
id = nxp_identifier_new_with_full_path(3,"gsl","gegenbauer", "poly3");
 nxp_bifunc_define(id, &nxp_prototype__REAL_REAL, nxp_gsl_sf_gegenpoly_3, NULL, nxp_gsl_sf_gegenpoly_3, context, NULL); nxp_identifier_unref(id);
id = nxp_identifier_new_with_full_path(3,"gsl","gegenbauer", "polyN");
 nxp_bifunc_define(id, &nxp_prototype__INT_REAL_REAL, nxp_gsl_sf_gegenpoly_n, NULL, nxp_gsl_sf_gegenpoly_n, context, NULL); nxp_identifier_unref(id);
id = nxp_identifier_new_with_full_path(3,"gsl","gegenbauer", "poly");
 nxp_bifunc_define(id, &nxp_prototype__INT_REAL_REAL, nxp_gsl_sf_gegenpoly_array, NULL, nxp_gsl_sf_gegenpoly_array, context, NULL); nxp_identifier_unref(id);
}
